<?php

namespace plugin\wz_chat\app\controller;

use support\Request;

use plugin\wz_chat\app\model\Users;
use plugin\wz_chat\app\model\Messages;
use plugin\wz_chat\app\model\Friends;
use plugin\wz_chat\app\model\Groups;
use plugin\wz_chat\app\model\GroupMembers;
use plugin\wz_chat\app\model\FriendRequests;
use support\Db;

class IndexController
{
    /***
     * 主站js函数：
     * function openDetachedWindow(url, width, height) {
		  // 生成一个随机的窗口名称，避免与现有窗口冲突
		  const windowName = 'detached_' + Math.random().toString(36).substring(2);
		  
		  // 计算窗口居中位置
		  const left = (window.screen.width - width) / 2;
		  const top = (window.screen.height - height) / 2;
		  
		  // 窗口特性参数
		  const features = `
		    width=${width},
		    height=${height},
		    left=${left},
		    top=${top},
		    resizable=yes,
		    scrollbars=yes,
		    toolbar=no,
		    menubar=no,
		    location=no,
		    status=no,
		    dependent=no
		  `.replace(/\s+/g, ''); // 移除所有空格
		  
		  // 打开新窗口
		  const newWindow = window.open(url, windowName, features);
		  
		  // 确保新窗口获得焦点
		  if (newWindow) {
		    newWindow.focus();
		  } else {
		    console.error('弹出窗口被浏览器阻止，请允许弹出窗口或检查浏览器设置。');
		  }
		  
		  return newWindow;
	 }
	 
	 <a href="javascript:openDetachedWindow('/app/wz_chat/index/index');">打开</a>
	 
	 <a href="javascript:openDetachedWindow('/app/wz_chat/index/index?user_id=<?=$user_id?>');">打开对话</a>
     * 
     * 
     * 需要安装 redis , 
     * 
     * 
     * 
     * 
     * 
     * 
     */
    
    /**
     * 入口页面
     */
    public function index(Request $request)
    {
        if (!session("user")) {//主站session
            return response('', 401);
        }
        
        $user= Users::where('id',session("user.id"))->first();//这个是查询的 wz_users  不是 wa_users
        if (!$user) {
            //下面是 对 wz_users 初始化一下 
            $user= new Users();
            $user->id = session("user.id");
            $user->nickname = session("user.nickname");
            $user->avatar = session("user.avatar");
            $user->verify = '1';
            $user->sign = session("user.sign",'');
            $user->online = '1';
            $user->save();
        }
        
        $user->online = 1;
        $user->save();
        
        $gids = $user->groups()->pluck('group_id')->toArray();
        $fids = $user->friends()->pluck('friend_id')->toArray();
        wz_user_online($user->id,$gids,$fids);   
        
        session(['wz-user'=>$user]);
        
        $chat_user = false;
        if($request->get('user_id')){
            $chat_user= Users::where('id',$request->get('user_id'))->first(['id','nickname','avatar'])->toArray();
        }
        return view('index/index', [
            'user' => $user,
            'chat_user'=>$chat_user
        ]);
        
    }
    
    /**
     * 获取好友列表
     */
    public function friends(Request $request)
    {
        $user_id = session("wz-user.id");
        
        $online_fids = wz_get_online_friends($user_id);
        
        $result = Friends::with(['friend:id,nickname,avatar,online,sign'])
        ->where('user_id', $user_id)
        ->where('relation_type', 1)
        ->get();
         
        $data = [];
        if(count($result)){
            foreach ($result as $item){
                $data[]=[
                    'id' => $item->friend_id,
                    'remark' => $item->remark, // 好友备注
                    'nickname' => $item->friend->nickname, // 好友昵称
                    'avatar' => $item->friend->avatar, // 头像URL
                    'online' => in_array($item->friend_id, $online_fids),
                    'sign' => $item->friend->sign, // 个性签名
                    'relation_type' => $item->relation_type, // 关系类型
                    'display_name' => $item->remark ?: $item->friend->nickname // 显示名称(优先使用备注)
                ];
            }
        }
        
        // 返回JSON格式
        return json([
            'code' => 0,
            'data' => $data,
            'count' => count($data)
        ]);
    }
    
    /**
     * 获取群组列表（包含在线人数）
     */
    public function groups(Request $request)
    {
        $user_id = session("wz-user.id");
        $groups = GroupMembers::with(['group:id,group_name,avatar,member_count,announcement'])
        ->where('user_id', $user_id)
        ->where('status', 1)
        ->get(['group_id', 'role']);
        
        $data = $groups->map(function ($item) {
            $group = $item->group;
            $gid = $item->group_id;           
            return [
                'id' => $gid,
                'group_name' => $group->group_name,
                'avatar' => $group->avatar,
                'member_count' => $group->member_count,
                'online_count' => wz_get_group_online_count($gid),
                'announcement'=>$group->announcement,
                'role' => $item->role,
            ];
        });
        return json([
            'code' => 0,
            'data' => $data
        ]);
    }
    
   
    //获取群组 人数
    public function groupOnlines(Request $request){
        $user_id = session("wz-user.id");
        $ids = $request->get('ids','');
        if($user_id && $ids){
            $ids = explode(',', $ids);
            $data = [];
            foreach ($ids as $id){
                $data[$id] = wz_get_group_online_count($id);
            }
            return json(["code"=>0,'data'=>$data]);
        }
        return json(["code"=>0,'data'=>[]]);
    }
    public function getUnread(Request $request)
    {
        $user_id = session("wz-user.id");
        $groups = $request->post('groups', []);
        $friends = $request->post('friends', []);
        
        $response = [
            'existing' => [],  // 已有会话的未读消息
            'new_chats' => []  // 新会话
        ];
        
        try {
            $real_fids = wz_get_friends($user_id);
            // 1. 处理群组未读消息（基于lastId查询）
            foreach ($groups as $gid => $lastId) {
                $unreadCount = Messages::where('receiver_id', $gid)
                ->where('session_type', Messages::SESSION_GROUP)
                ->where('id', '>', $lastId)
                ->where('status', 1)
                ->where('sender_id', '!=', $user_id)  // 排除自己发的消息
                ->count();
                
                if ($unreadCount > 0) {
                    $lastMessage = Messages::where('receiver_id', $gid)
                    ->where('session_type', Messages::SESSION_GROUP)
                    ->orderBy('id', 'desc')
                    ->with('sender:id,nickname')
                    ->first();
                    $nickname = $lastMessage->sender_id==$user_id?'我：':$lastMessage->sender->nickname.'：';
                    $response['existing'][] = [
                        'id' => $gid,
                        'group' => true,
                        'unread' => $unreadCount,
                        'lastId' => $lastMessage->id,
                        'lastMsg' =>$nickname.$lastMessage->abstract
                    ];
                }
            }
            
            // 2. 处理好友未读消息（基于lastId查询）
            foreach ($friends as $fid => $lastId) {
                $unreadCount = Messages::where(function($query) use ($user_id, $fid) {
                    $query->where('sender_id', $fid)
                    ->where('receiver_id', $user_id);
                })
                ->where('id', '>', $lastId)
                ->where('session_type', Messages::SESSION_PRIVATE)
                ->where('status', 1)
                ->count();
                
                if ($unreadCount > 0) {
                    
                    $lastMessage = Messages::whereRaw(" ((sender_id = '{$fid}' and receiver_id='{$user_id}') or (sender_id = '{$user_id}' and receiver_id='{$fid}') ) and session_type='0'")
                    ->orderBy('id', 'desc')
                    ->first();
                    $nickname = $lastMessage->sender_id==$user_id?'我：':'TA：';
                    $response['existing'][] = [
                        'id' => $fid,
                        'group' => false,
                        'unread' => $unreadCount,
                        'lastId' => $lastMessage->id,
                        'lastMsg' => $nickname.$lastMessage->abstract,
                        'is_friend'=>in_array($fid, $real_fids)
                    ];
                }
            }
            
            // 3. 查询新的私聊会话（不在friends列表中的）
            $newSenders = Messages::where('receiver_id', $user_id)
            ->where('session_type', Messages::SESSION_PRIVATE)
            ->where('status', 1)
            ->where('is_read', 0)
            ->whereNotIn('sender_id', array_keys($friends))
            ->groupBy('sender_id')
            ->pluck('sender_id');
            
            foreach ($newSenders as $senderId) {
                
                $lastMessage = Messages::whereRaw(" ((sender_id = '{$senderId}' and receiver_id='{$user_id}') or (sender_id = '{$user_id}' and receiver_id='{$senderId}') ) and session_type='0'")
                ->orderBy('id', 'desc')
                ->first();
                
                $unreadCount = Messages::where('receiver_id', $user_id)
                ->where('sender_id', $senderId)
                ->where('session_type', Messages::SESSION_PRIVATE)
                ->where('status', 1)
                ->where('is_read', 0)
                ->count();
                
                $sender = Users::select(['id', 'nickname', 'avatar'])->find($senderId);
                $nickname = $lastMessage->sender_id==$user_id?'我：':'TA：';
                $response['new_chats'][] = [
                    'id' => $senderId,
                    'name' => $sender->nickname,
                    'avatar' => $sender->avatar, 
                    'lastMsg' => $nickname.$lastMessage->abstract,
                    'lastId' => $lastMessage->id,
                    'time' => strtotime($lastMessage->sent_time) * 1000,
                    'group' => false,
                    'unread' => $unreadCount,
                    'members' => 1,
                    'is_friend'=>in_array($fid, $real_fids)
                ];
            }
            
            // 4. 查询新的群组会话（不在groups列表中的）
            $newGroups = wz_get_user_groups($user_id,array_keys($groups));
            
            foreach ($newGroups as $groupId) {
                $lastMessage = Messages::where('receiver_id', $groupId)
                ->where('session_type', Messages::SESSION_GROUP)
                ->with("sender:id,nickname")
                ->orderBy('id', 'desc')
                ->first();
                
                if (!$lastMessage) continue;
                
                $group = Groups::find($groupId);  // 假设有Group模型
                $nickname = $lastMessage->sender_id==$user_id?'我：':$lastMessage->sender->nickname.'：';
                $response['new_chats'][] = [
                    'id' => $groupId,
                    'name' => $group->group_name,
                    'avatar' => $group->avatar,
                    'lastMsg' => $nickname.$lastMessage->abstract,
                    'lastId' => $lastMessage->id,
                    'time' => strtotime($lastMessage->sent_time) * 1000,
                    'group' => true,
                    'unread' => 0,
                    'members' => $group->member_count,
                ];
            }
            
            return json(['code' => 0, 'data' => $response]);
            
        } catch (\Exception $e) {
            return json(['code' => 1, 'msg' => '获取未读消息失败: ' . $e->getMessage()]);
        }
    }
    
    public function searchUser(Request $request){
        $user_id = session("wz-user.id");
        $keyword = $request->get('keyword','');
        if($user_id && $keyword){
            $users = [];
            if(is_numeric($keyword)){
                if($keyword!=$user_id){
                    $user = Users::where("id",$keyword)->first();
                    if($user){
                        $users[]=$user;
                    }
                }
            }else{
                $users = Users::where("nickname",'like',"%{$keyword}%")->where("id",'<>',$user_id)->get();
            }
            return json(['code'=>0,"data"=>$users]);
        }
        return json(['code'=>0,"data"=>[]]);
    }
    /**
     * 获取我申请的和申请我的
     * @param Request $request
     */
    public function requests(Request $request){
        $user_id = session("wz-user.id");
        $sent = FriendRequests::where('requester_id',$user_id)->with('receiver')->where("status",'pending')->orderByDesc('id')->get();
        $received = FriendRequests::where("receiver_id",$user_id)->with('requester')->where("status","pending")->orderByDesc('id')->get();
        return json(['code'=>0,'data'=>[
            'sent'=>$sent,
            'received'=>$received
        ]]);
    }
    /**
    * 发送好友申请
    */
    public function requestFriend(Request $request)
    {
          
        
        
        Db::beginTransaction();
        try {
            $user = session("wz-user");
            $user_id = $user['id'];
            $receiver_id = $request->post('receiver_id');
            $message = $request->post('message', '');
    
            // 1. 校验是否自己申请自己
            if ($user_id == $receiver_id) {
                return json(['code' => 1, 'msg' => '不能添加自己为好友']);
            }
    
            // 2. 检查是否已经是好友
            $isFriend = Friends::where(function ($query) use ($user_id, $receiver_id) {
                $query->where('user_id', $user_id)
                    ->where('friend_id', $receiver_id)
                    ->where('relation_type', 1);
            })->exists();
    
            if ($isFriend) {
                return json(['code' => 1, 'msg' => '你们已经是好友了']);
            }
    
            // 3. 获取对方用户信息
            $friend = Users::find($receiver_id);
            if (!$friend) {
                return json(['code' => 1, 'msg' => '用户不存在']);
            }
            
            $receiver_online = wz_user_is_online($receiver_id);
            
            // 4. 检查对方是否已申请自己（自动通过）
            $reverseRequest = FriendRequests::where('requester_id', $receiver_id)
                ->where('receiver_id', $user_id)
                ->where('status', 'pending')
                ->first();
    
            if ($reverseRequest) {
                // 通过对方申请
                $reverseRequest->accept();
                // 创建双向好友关系
                Friends::create([
                    'user_id' => $user_id,
                    'friend_id' => $receiver_id,
                    'relation_type' => 1
                ]);
                Friends::create([
                    'user_id' => $receiver_id,
                    'friend_id' => $user_id,
                    'relation_type' => 1
                ]);
                // 推送通知
                
                if($receiver_online){
                    wz_push($receiver_id, [
                        'type' => 'request_success',
                        'data' => [
                            'user'=>[
                                'id'=>$user_id,
                                'remark'=>'',
                                'nickname'=>$user['nickname'],
                                'avatar'=>$user['avatar']??'',
                                'online'=>true,
                                'sign'=>$user['sign']??'',
                                'relation_type'=>1,
                                'display_name'=>$user['nickname']??$user['id'],
                                
                            ],
                            'msg'=>session('wz-user.nickname').' 通过了您的好友申请',
                            'sent_id'=>$reverseRequest->id
                        ]
                    ]);
                }
                
                wz_push($user_id, [
                    'type' => 'request_success',
                    'data' => [
                        'user'=>[
                            'id'=>$friend->id,
                            'remark'=>'',
                            'nickname'=>$friend->nickname,
                            'avatar'=>$friend->avatar,
                            'online'=>$receiver_online,
                            'sign'=>$friend->sign,
                            'relation_type'=>1,
                            'display_name'=>$friend->nickname
                        ],
                        'msg'=>'已成功添加 '.$friend->nickname.' 为好友',
                        'received_id'=>$reverseRequest->id
                    ]
                ]);
                
                wz_add_friend($user_id, $friend->id,$receiver_online);//双向绑定关系到 redis
                
                Db::commit();
                return json(['code' => 0, 'msg' => '']);
            }
    
            // 5. 处理无需验证的情况
            if ($friend->verify == 1) {
                // 直接建立好友关系
                Friends::create([
                    'user_id' => $user_id,
                    'friend_id' => $receiver_id,
                    'relation_type' => 1
                ]);
    
                Friends::create([
                    'user_id' => $receiver_id,
                    'friend_id' => $user_id,
                    'relation_type' => 1
                ]);
    
                // 删除可能存在的申请记录
                FriendRequests::where('requester_id', $user_id)
                    ->where('receiver_id', $receiver_id)
                    ->delete();
                if($receiver_online){
                    wz_push($receiver_id, [
                        'type' => 'request_success',
                        'data' => [
                            'user'=>[
                                'id'=>$user_id,
                                'remark'=>'',
                                'nickname'=>$user['nickname'],
                                'avatar'=>$user['avatar']??'',
                                'online'=>true,
                                'sign'=>$user['sign']??'',
                                'relation_type'=>1,
                                'display_name'=>$user['nickname']??$user['id'],
                                
                            ],
                            'msg'=>session('wz-user.nickname').' 添加了您为好友',
                        ]
                    ]);
                }
                // 推送通知
                wz_push($user_id, [
                    'type' => 'request_success',
                    'data' => [
                        'user'=>[
                            'id'=>$friend->id,
                            'remark'=>'',
                            'nickname'=>$friend->nickname,
                            'avatar'=>$friend->avatar,
                            'online'=>$receiver_online,
                            'sign'=>$friend->sign,
                            'relation_type'=>1,
                            'display_name'=>$friend->nickname
                        ],
                        'msg'=>'已成功添加 '.$friend->nickname.' 为好友'
                    ]
                ]);
                
                wz_add_friend($user_id, $friend->id,$receiver_online);//双向绑定关系到 redis
                
                Db::commit();
                return json(['code' => 0, 'msg' => '']);
            }
    
            // 6. 需要验证的情况
            // 检查是否已有申请记录
            $request_row = FriendRequests::where("requester_id",$user_id)->where("receiver_id",$friend->id)->first();
            if(!$request_row){
                $request_row = new FriendRequests();
                $request_row->requester_id = $user_id;
                $request_row->receiver_id = $friend->id;
            }
            $request_row->status = 'pending';
            $request_row->save();
            $request_arr = $request_row->toArray();
            // 推送申请通知
            if($receiver_online){ 
                $received = $request_arr + ['requester'=>session('wz-user')];
                wz_push($friend->id, [
                    'type' => 'request_received',
                    'data' => [
                        'received'=>$received,
                        'msg'=>session('wz-user.nickname').' 请求添加您为好友'
                    ]
                ]);
            } 
            $sent = $request_arr + ['receiver'=>$friend->toArray()];
            wz_push($user_id, [
                'type' => 'request_sent', 
                'data' => [
                    'sent'=>$sent,
                    'msg'=>'成功向'.$friend->nickname.'发出申请'
                ]
            ]); 
        
            Db::commit();
            return json([
                'code' => 0,
                'msg' => '',
            ]);
        } catch (\Exception $e) {
            Db::rollBack();
            return json(['code' => 1, 'msg' => $e->getMessage()]);
        }
    }
    /**
 * 通过好友申请
 * @param Request $request
 */
    public function requestAccept(Request $request)
    {
        Db::beginTransaction();
        try {
            $user_id = session("wz-user.id");
            $id = $request->post('id');
            
            // 1. 获取申请记录
            $request_info = FriendRequests::where("id", $id)
                ->where("receiver_id", $user_id)
                ->first();
                
            if (!$request_info) {
                return json(['code' => 1, 'msg' => '申请记录不存在']);
            }
            
            // 2. 检查是否已经是好友
            $isFriend = Friends::where(function ($query) use ($user_id, $request_info) {
                $query->where('user_id', $user_id)
                    ->where('friend_id', $request_info->requester_id)
                    ->where('relation_type', 1);
            })->exists();
            
            if ($isFriend) {
                return json(['code' => 1, 'msg' => '你们已经是好友了']);
            }
            
            // 3. 获取申请者信息
            $requester = Users::find($request_info->requester_id);
            if (!$requester) {
                return json(['code' => 1, 'msg' => '申请用户不存在']);
            }
            
            $requester_online = wz_user_is_online($requester->id);
            
            // 4. 通过申请
            $request_info->accept();
            
            // 5. 创建双向好友关系
            Friends::create([
                'user_id' => $user_id,
                'friend_id' => $requester->id,
                'relation_type' => 1
            ]);
            
            Friends::create([
                'user_id' => $requester->id,
                'friend_id' => $user_id,
                'relation_type' => 1
            ]);
            
            // 6. 推送通知
            if ($requester_online) {
                wz_push($requester->id, [
                    'type' => 'request_success',
                    'data' => [
                        'user' => [
                            'id' => $user_id,
                            'remark' => '',
                            'nickname' => session('wz-user.nickname'),
                            'avatar' => session('wz-user.avatar'),
                            'online' => true,
                            'sign' => session('wz-user.sign'),
                            'relation_type' => 1,
                            'display_name' => session('wz-user.nickname')
                        ],
                        'msg' => session('wz-user.nickname').' 通过了您的好友申请',
                        'sent_id' => $request_info->id
                    ]
                ]);
            }
            
            wz_push($user_id, [
                'type' => 'request_success',
                'data' => [
                    'user' => [
                        'id' => $requester->id,
                        'remark' => '',
                        'nickname' => $requester->nickname,
                        'avatar' => $requester->avatar,
                        'online' => $requester_online,
                        'sign' => $requester->sign,
                        'relation_type' => 1,
                        'display_name' => $requester->nickname
                    ],
                    'msg' => '已成功添加 '.$requester->nickname.' 为好友',
                    'received_id' => $request_info->id
                ]
            ]);
            
            // 7. 更新redis好友关系
            wz_add_friend($user_id, $requester->id, $requester_online);
            
            Db::commit();
            return json(['code' => 0, 'msg' => '']);
            
        } catch (\Exception $e) {
            Db::rollBack();
            return json(['code' => 1, 'msg' => $e->getMessage()]);
        }
        
    }
    /**
     * 拒绝对方申请
     * @param Request $request
     */
    public function requestReject(Request $request){
        Db::beginTransaction();
        try {
            $user_id = session("wz-user.id");
            $id = $request->post('id');
            
            // 1. 获取申请记录
            $request_info = FriendRequests::where("id", $id)
            ->where("receiver_id", $user_id)
            ->first();
            
            if (!$request_info) {
                return json(['code' => 1, 'msg' => '申请记录不存在']);
            }
            
            $requester_online = wz_user_is_online($request_info->requester_id);
            
            // 4. 拒绝申请
            $request_info->reject();
            
            // 6. 推送通知
            if ($requester_online) {
                wz_push($request_info->requester_id, [
                    'type' => 'request_reject',
                    'data' => [
                        'sent_id' => $request_info->id
                    ]
                ]);
            }
            
            Db::commit();
            return json(['code' => 0, 'msg' => '']);
            
        } catch (\Exception $e) {
            Db::rollBack();
            return json(['code' => 1, 'msg' => $e->getMessage()]);
        }
    }
    public function messageHistorys(Request $request)
    {
        $user_id = session("wz-user.id");
        $id = $request->get('id'); // 好友id或群id
        $is_group = $request->get('group', '0') == '1';
        $mid = intval($request->get('mid', -1)); // 消息ID分界点 
        
        try {
            // 验证用户是否有权限查看这些消息
            if ($is_group) {
                $query = Messages::where('receiver_id', $id)
                ->where('session_type', Messages::SESSION_GROUP);
                
            } else {
                Messages::where('session_type',Messages::SESSION_PRIVATE)
                ->where('receiver_id',$user_id)->where('sender_id',$id)->update(['is_read'=>1]);
                
                $query = Messages::where(function($query) use ($user_id, $id) {
                    $query->where('sender_id', $user_id)
                    ->where('receiver_id', $id)
                    ->where('session_type', Messages::SESSION_PRIVATE);
                })->orWhere(function($query) use ($user_id, $id) {
                    $query->where('sender_id', $id)
                    ->where('receiver_id', $user_id)
                    ->where('session_type', Messages::SESSION_PRIVATE);
                });
            }
            
            // 添加消息ID条件
            if ($mid != -1) {
                $query->where('id', '<', $mid);
            }
            
            // 获取消息并按ID倒序排列
            $messages = $query->orderBy('id', 'desc')
            ->limit(20)
            ->with(['sender' => function($query) {
                $query->select('id', 'nickname', 'avatar');
            }])
            ->where('status',1)
            ->get()
            ->reverse() // 将结果反转为正序
            ->values(); // 重置数组键名
            
            // 格式化消息数据
            $formattedMessages = $messages->map(function($message) use ($user_id) { 
                return [
                    'id' => $message->id, 
                    'type' => $message->sender_id == $user_id ? 'sent' : 'received',
                    'sender' => $message->sender_id == $user_id ? null : $message->sender,
                    'content' => $message->content,
                    'time' => strtotime($message->sent_time) * 1000, // 转换为前端需要的毫秒时间戳
                    'msg_type' => $message->msg_type,
                    'showTime' => false, // 前端会根据需要设置是否显示时间
                    'file_size'=>$message->file_size,
                    'duration'=>$message->duration,
                    'thumbnail'=>$message->thumbnail,
                    'is_read'=>$message->is_read,
                    'extra'=>$message->extra,
                ];
            });
            
            
            return json(['code' => 0, 'data' => $formattedMessages]);
                
        } catch (\Exception $e) {
            return json(['code' => 1, 'msg' => '获取历史消息失败: ' . $e->getMessage()]);
        }
    }
    
    
    
    /**
     * 发送消息
     */
    public function sendMessage(Request $request)
    {
        $user_id = session("wz-user.id");
        $id = $request->post('id'); // 接收者ID(好友或群ID)
        $is_group = $request->post('group', '0') == '1';
        $content = $request->post('content');
        $msg_type = $request->post('msg_type', 1); // 默认为文本消息
        $file_size = $request->post('file_size', 0);
        $duration = $request->post('duration', 0);
        $thumbnail = $request->post('thumbnail', '');
        $extra = $request->post('extra', ''); // 额外数据(如链接消息的标题、描述等)
    
        try {
            // 验证基本参数
            if (empty($id)) {
                throw new \Exception("接收者ID不能为空");
            }
            
            if (empty($content) && $msg_type == 1) {
                throw new \Exception("消息内容不能为空");
            }
            $is_read = 0;
            // 验证接收者是否存在
            if ($is_group) {
                // 验证群组是否存在且用户是否在群中
                $isMember = wz_is_group_member($user_id, $id);
                if (!$isMember) {
                    throw new \Exception("您不在该群组中");
                }
                $is_read =1;
            }else{
                $is_read = wz_user_is_online($id)?1:0;
            }
            
            
            
            // 创建消息记录
            $message = new Messages();
            $message->sender_id = $user_id;
            $message->receiver_id = $id;
            $message->session_type = $is_group ? Messages::SESSION_GROUP : Messages::SESSION_PRIVATE;
            $message->content = $content;
            $message->msg_type = $msg_type;
            $message->file_size = $file_size;
            $message->duration = $duration;
            $message->thumbnail = $thumbnail;
            $message->extra = $extra;
            $message->sent_time = date('Y-m-d H:i:s');
            $message->status = 1;
            $message->is_read = $is_read;
            $message->save();
            
            
            // 获取发送者信息
            $sender = $message->sender;
            
            // 格式化返回数据
            $message_format1= [
                'id' => $message->id,
                'type' => 'sent',
                'sender' => null, // 发送方不需要显示自己信息
                'content' => $content,
                'time' => strtotime($message->sent_time) * 1000,
                'msg_type' => $msg_type,
                'showTime' => false,
                'file_size' => $file_size,
                'duration' => $duration,
                'thumbnail' => $thumbnail,
                'is_read' => 1,
                'extra' => $extra,
            ];
            
            // 准备WebSocket推送数据
            $message_format2 = [
                'id' => $message->id,
                'type' => 'received', // 对接收方来说是received
                'sender' => $sender, // 对接收方需要显示发送者信息
                'content' => $content,
                'time' => strtotime($message->sent_time) * 1000,
                'msg_type' => $msg_type,
                'showTime' => false,
                'file_size' => $file_size,
                'duration' => $duration,
                'thumbnail' => $thumbnail,
                'is_read' => $is_group?1:0,
                'extra' => $extra,
            ];
            
            $pushData = [
                'type' => $is_group ? 'group' : 'private',
                'sender_id' => $user_id,
                'group_id' => $is_group ? $id : null, 
                'abstract'=>($is_group?$sender->nickname.'：':'TA：').$message->abstract, 
                'data' => $message_format2
            ];
            
            
            if ($is_group) {
                $mids = wz_get_group_online_users($id,$user_id);
                if (!empty($mids)) {
                    wz_push($mids, [
                        'type'=>'new_message',
                        'data'=>$pushData
                    ]);
                }
            } else {
                if(wz_user_is_online($id)){
                    wz_push($id, [
                        'type'=>'new_message',
                        'data'=>$pushData
                    ]);
                }              
            }
            
            return json(['code' => 0, 'data' => $message_format1, 'msg' => '消息发送成功']);
            
        } catch (\Exception $e) {
            return json(['code' => 1, 'msg' => '消息发送失败: ' . $e->getMessage()]);
        }
    }
    public function groupRename(Request $request){
        $user_id = session("wz-user.id");
        $group_id= $request->post('group_id');
        $name = $request->post("name");
        if(!$name){
            return json(['code'=>1,'msg'=>'名称不能为空']);
        }
        $group = Groups::find($group_id);
        if($group->creator_id==$user_id){
            
            $old_name = $group->group_name;
            $group->group_name = $name;
            $group->save();
            
            
            $content = "修改群名称：'{$old_name}'=>'{$name}' ";
            $message = new Messages();
            $message->sender_id = $user_id;
            $message->receiver_id = $group->id;
            $message->session_type = Messages::SESSION_GROUP;
            $message->content = $content;
            $message->msg_type = '1';
            $message->sent_time = date('Y-m-d H:i:s');
            $message->status = 1;
            $message->is_read = 1;
            $message->save();
            
            $message_format2 = [
                'id' => $message->id,
                'type' => 'received',
                'sender' => $message->sender,
                'content' => $content,
                'time' => strtotime($message->sent_time) * 1000,
                'msg_type' => $message->msg_type,
                'showTime' => false,
                'file_size' => $message->file_size,
                'duration' => $message->duration,
                'thumbnail' => $message->thumbnail,
                'is_read' => 1,
                'extra' => $name,
            ]; 
            
            $pushData = [
                'type' => 'group',
                'sender_id' => $user_id,
                'group_id' => $group_id,
                'abstract'=>$content,
                'data' => $message_format2
            ];
            $mids = wz_get_group_online_users($group_id);
            if (!empty($mids)) {
                wz_push($mids, [
                    'type'=>'group_rename',
                    'data'=>$pushData
                ]);
            }
            return json(['code'=>0,'msg'=>'操作成功']);
        }
        return json(['code'=>1,'msg'=>'无权限']);
    }
    
    public function groupAnnouncement(Request $request){
        $user_id = session("wz-user.id");
        $announcement = $request->post('announcement');
        $group_id = $request->post('group_id');
        
        $group = Groups::find($group_id);
        if($group){
            if($group->creator_id != $user_id){
                $exist = GroupMembers::where("group_id",$group_id)->where("user_id",$user_id)->where('role',1)->exists();
                if(!$exist){
                    return json(['code'=>0,'msg'=>'无权限']);
                }
            }
        }
        $group->announcement = $announcement;
        $group->save();
        $mids = wz_get_group_online_users($group_id);
        if (!empty($mids)) {
            wz_push($mids, [
                'type'=>'group_announcement',
                'data'=>[
                    'group_id'=>$group_id,
                    'announcement'=>$announcement
                ]
            ]);
        }
        return json(['code'=>0,'msg'=>'操作成功']);
        
        
        
    }
    public function groupRemoveMember(Request $request)
    {
        $group_id = $request->post("group_id");
        $user_id = $request->post("user_id");
        $current_user_id = session("wz-user.id"); // 當前操作者ID
        
        // 驗證輸入
        if (empty($group_id) || empty($user_id)) {
            return json(['code' => 1, 'msg' => '參數錯誤']);
        }
        
        try {
            // 獲取群組信息
            $group = Groups::find($group_id);
            if (!$group) {
                return json(['code' => 1, 'msg' => '群組不存在']);
            }
            
            // 檢查當前用戶是否有權限移除成員 (群主或管理員)
            $current_user_role = GroupMembers::where('group_id', $group_id)
            ->where('user_id', $current_user_id)
            ->value('role');
            
            if (!in_array($current_user_role, [GroupMembers::ROLE_OWNER, GroupMembers::ROLE_ADMIN])) {
                return json(['code' => 1, 'msg' => '沒有權限執行此操作']);
            }
            
            // 不能移除自己
            if ($user_id == $current_user_id) {
                return json(['code' => 1, 'msg' => '不能移除自己']);
            }
            
            // 檢查目標用戶是否在群組中
            $target_member = GroupMembers::where('group_id', $group_id)
            ->where('user_id', $user_id)
            ->first();
            
            if (!$target_member) {
                return json(['code' => 1, 'msg' => '該用戶不在群組中']);
            }
            
            // 不能移除群主
            if ($target_member->role == GroupMembers::ROLE_OWNER) {
                return json(['code' => 1, 'msg' => '不能移除群主']);
            }
            
            // 開始事務
            Db::beginTransaction();
            
            // 1. 從群組成員表中移除
            GroupMembers::where('group_id', $group_id)
            ->where('user_id', $user_id)
            ->delete();
            
            // 2. 更新群組成員數
            $group->member_count = GroupMembers::where('group_id', $group_id)->count();
            $group->save();
            
            // 3. 調用業務邏輯移除用戶
            wz_group_remove_user($group_id, $user_id);
            
            // 4. 創建系統消息
            $operator = Users::find($current_user_id);
            $target_user = Users::find($user_id);
            $now = date('Y-m-d H:i:s');
            
            $message = new Messages();
            $message->sender_id = $current_user_id;
            $message->receiver_id = $group_id;
            $message->session_type = Messages::SESSION_GROUP;
            $message->content = "{$operator->nickname} 將 {$target_user->nickname} 移出了群組";
            $message->msg_type = Messages::TYPE_TEXT;
            $message->sent_time = $now;
            $message->status = Messages::STATUS_NORMAL;
            $message->is_read = 1;
            $message->save();
            
            // 5. 獲取在線成員數
            $online_count = wz_get_group_online_count($group_id);
            
            // 6. 準備WebSocket推送數據
            $pushData = [
                'type' => 'group_member_removed',
                'data' => [
                    'message'=>[
                        'id' => $message->id,
                        'type' => 'received',
                        'sender' => [
                            'id' => $operator->id,
                            'nickname' => $operator->nickname,
                            'avatar' => $operator->avatar
                        ],
                        'content' => $message->content,
                        'time' => strtotime($now) * 1000,
                        'msg_type' => $message->msg_type,
                        'showTime' => false,
                        'file_size' => 0,
                        'duration' => 0,
                        'thumbnail' => '',
                        'is_read' => 1,
                        'extra' => '',
                    ],
                    'group'=>[
                        'id' => $group->id,
                        'group_name' => $group->group_name,
                        'avatar' => $group->avatar,
                        'member_count' => $group->member_count,
                        'online_count' => $online_count,
                        'announcement'=>$group->announcement,
                        'role' => 0,
                    ],
                    'removed_user_id' => $user_id
                ]
            ];
            
            // 7. 推送到群組頻道
            $mids = wz_get_group_online_users($group_id);
            wz_push($mids, $pushData);
            
            
            Db::commit();
            
            return json([
                'code' => 0,
                'msg' => '成員移除成功',
                'data' => [
                    'member_count' => $group->member_count
                ]
            ]);
            
        } catch (\Exception $e) {
            Db::rollBack();
            return json(['code' => 1, 'msg' => '移除成員失敗: ' . $e->getMessage()]);
        }
    }
    
    /**
     * 拉人进群
     * @param Request $request
     * @return Response
     */
    public function groupAddMembers(Request $request)
    {
        $group_id = $request->post('group_id');
        $members = $request->post('members'); // 数组，用户id
        $user_id = session("wz-user.id");
    
        // 验证参数
        if (empty($group_id)) {
            return json(['code' => 1, 'msg' => '群组ID不能为空']);
        }
    
        if (!is_array($members) || empty($members)) {
            return json(['code' => 1, 'msg' => '成员参数格式错误或为空']);
        }
    
        // 检查群组是否存在
        $group = Groups::find($group_id);
        if (!$group) {
            return json(['code' => 1, 'msg' => '群组不存在']);
        }
    
        // 检查操作者是否有权限（群主或管理员）
        /*
        $operatorRole = GroupMembers::where('group_id', $group_id)
            ->where('user_id', $user_id)
            ->value('role');
        
        if (!in_array($operatorRole, [GroupMembers::ROLE_OWNER, GroupMembers::ROLE_ADMIN])) {
            return json(['code' => 1, 'msg' => '没有权限操作']);
        }
        */
    
        // 过滤已存在的成员
        $existingMembers = GroupMembers::where('group_id', $group_id)
            ->whereIn('user_id', $members)
            ->pluck('user_id')
            ->toArray();
        
        $newMembers = array_diff($members, $existingMembers);
    
        if (empty($newMembers)) {
            return json(['code' => 1, 'msg' => '所选用户已在群中']);
        }
    
        // 使用事务确保数据一致性
        Db::beginTransaction();
        try {
            $now = date('Y-m-d H:i:s');
            $membersData = [];
            
            foreach ($newMembers as $memberId) {
                $membersData[] = [
                    'group_id' => $group_id,
                    'user_id' => $memberId,
                    'role' => GroupMembers::ROLE_MEMBER,
                    'status' => GroupMembers::STATUS_ACTIVE,
                    'join_time' => $now
                ];
            }
    
            // 批量添加成员
            GroupMembers::insert($membersData);
    
            // 更新群成员数量
            $group->member_count = GroupMembers::where('group_id', $group_id)->count();
            $group->save();
    
            // 调用业务逻辑添加用户
            wz_group_add_user($group_id, $newMembers);
    
            // 创建系统消息
            $message = new Messages();
            $message->sender_id = $user_id;
            $message->receiver_id = $group_id;
            $message->session_type = Messages::SESSION_GROUP;
            $message->content = "邀请了 " . count($newMembers) . " 位成员加入群聊";
            $message->msg_type = Messages::TYPE_TEXT;
            $message->sent_time = $now;
            $message->status = Messages::STATUS_NORMAL;
            $message->is_read = 0;
            $message->save();
    
            // 获取在线成员数
            $online_count = wz_get_group_online_count($group_id);
            
            // 准备WebSocket推送数据
            $pushData = [
                'type' => 'group_member_added',
                'data' => [
                    'message'=>[
                        'id' => $message->id,
                        'type' => 'received',
                        'sender' => $message->sender,
                        'content' => $message->content,
                        'time' => strtotime($message->sent_time) * 1000,
                        'msg_type' => $message->msg_type,
                        'showTime' => false,
                        'file_size' => 0,
                        'duration' => 0,
                        'thumbnail' => '',
                        'is_read' => 1,
                        'extra' => '',
                    ],
                    'group'=>[
                        'id' => $group->id,
                        'group_name' => $group->group_name,
                        'avatar' => $group->avatar,
                        'member_count' => $group->member_count,
                        'online_count' => $online_count,
                        'announcement'=>$group->announcement,
                        'role' => 0,
                    ]
                ]
            ];
            
            $mids = wz_get_group_online_users($group_id);
            
            wz_push($mids, $pushData);
    
            Db::commit();
    
            return json([
                'code' => 0,
                'msg' => '添加成员成功'
            ]);
    
        } catch (\Exception $e) {
            Db::rollBack();
            return json(['code' => 1, 'msg' => '添加成员失败: ' . $e->getMessage()]);
        }
    }
    
    /**
     * 建群
     * @param Request $request
     * @return Response
     */
    public function createGroup(Request $request)
    {
        $user_id = session("wz-user.id");
        $name = $request->post('name'); // 群名称
        $mids = $request->post('members', []); // 数组，用户id
        
        // 验证参数
        if (empty($name)) {
            return json(['code' => 1, 'msg' => '群名称不能为空']);
        }
        
        if (!is_array($mids)) {
            return json(['code' => 1, 'msg' => '成员参数格式错误']);
        }
        
        // 确保创建者也在群成员中
        $members = array_unique(array_merge($mids, [$user_id]));
        
        // 检查成员数量是否合理
        if (count($members) < 1) {
            return json(['code' => 1, 'msg' => '群成员不能为空']);
        }
        
        // 使用事务确保数据一致性
        Db::beginTransaction();
        try {
            // 创建群组
            $group = new Groups();
            $group->avatar = session('wz-user.avatar');
            $group->group_name = $name;
            $group->creator_id = $user_id;
            $group->member_count = count($members);
            $group->status = Groups::STATUS_ACTIVE;
            $group->created_at = date('Y-m-d H:i:s');
            $group->announcement = '';
            $group->save();
            
            // 添加群成员
            $membersData = [];
            $now = date('Y-m-d H:i:s');
            foreach ($members as $memberId) {
                $role = $memberId == $user_id ? GroupMembers::ROLE_OWNER : GroupMembers::ROLE_MEMBER;
                
                $membersData[] = [
                    'group_id' => $group->id,
                    'user_id' => $memberId,
                    'role' => $role,
                    'status' => GroupMembers::STATUS_ACTIVE,
                    'join_time' => $now
                ];
            }
            
            GroupMembers::insert($membersData);
            
            wz_group_add_user($group->id, $members);
            
            
            // 创建消息
            $message = new Messages();
            $message->sender_id = $user_id;
            $message->receiver_id = $group->id;
            $message->session_type = Messages::SESSION_GROUP;
            $message->content = "创建了群组";
            $message->msg_type = '1';
            $message->sent_time = date('Y-m-d H:i:s');
            $message->status = 1;
            $message->is_read = 1;
            $message->save();
            
            $online_count = wz_get_group_online_count($group->id);
            // 准备WebSocket推送数据
            $pushData = [
                'type' => 'new_group',
                'data' => [
                    'message'=>[
                        'id' => $message->id,
                        'type' => 'received',
                        'sender' => $message->sender,
                        'content' => $message->content,
                        'time' => strtotime($message->sent_time) * 1000,
                        'msg_type' => $message->msg_type,
                        'showTime' => false,
                        'file_size' => 0,
                        'duration' => 0,
                        'thumbnail' => '',
                        'is_read' => 1,
                        'extra' => '',
                    ],
                    'group'=>[
                        'id' => $group->id,
                        'group_name' => $group->group_name,
                        'avatar' => $group->avatar,
                        'member_count' => $group->member_count,
                        'online_count' => $online_count,
                        'announcement'=>$group->announcement,
                        'role' => 0,
                    ]
                ]
            ];
            
            wz_push($mids, $pushData);
            Db::commit();
            
            // 返回创建成功的群组信息
            return json([
                'code' => 0,
                'msg' => '群组创建成功',
                'data' => [
                    'message'=>[
                        'id' => $message->id,
                        'type' => 'sent',
                        'sender' => null,
                        'content' => $message->content,
                        'time' => strtotime($message->sent_time) * 1000,
                        'msg_type' => $message->msg_type,
                        'showTime' => false,
                        'file_size' => 0,
                        'duration' => 0,
                        'thumbnail' => '',
                        'is_read' => 1,
                        'extra' => '',
                    ],
                    'group'=>[
                        'id' => $group->id,
                        'group_name' => $group->group_name,
                        'avatar' => $group->avatar,
                        'member_count' => $group->member_count,
                        'online_count' => $online_count,
                        'announcement'=>$group->announcement,
                        'role' => 2,
                    ]
                ]
            ]);
        } catch (\Exception $e) {
            Db::rollBack();
            return json(['code' => 1, 'msg' => '群组创建失败，请稍后再试']);
        }
    }
    public function groupSetAdmin(Request $request){
        $group_id = $request->post('group_id');
        $user_id = $request->post('user_id');
        $is_admin = $request->post('is_admin');
        $group = Groups::find($group_id);
        if($group->creator_id == session('wz-user.id')){
            $group_user = GroupMembers::where("group_id",$group_id)->where("user_id",$user_id)->first();
            $group_user->role = $is_admin;
            $group_user->save();
            if(wz_user_offline($user_id)){
                wz_push($user_id, [
                    'type'=>'group_admin',
                    'data'=>[
                        'group_id'=>$group_id,
                        'is_admin'=>$is_admin
                    ]
                ]);
            }
            
        }
        return json(['code'=>0,"msg"=>"操作成功"]);
        
    }
    public function editfriendRemark(Request $request){
        $user_id = session("wz-user.id");
        $fid = $request->post("fid");
        $remark = $request->post("remark");
        Friends::where("user_id",$user_id)->where("friend_id",$fid)->update(["remark"=>$remark]);
        return json(["code"=>0,"msg"=>"ok"]);
    }
    public function clearChatRecord(Request $request){
        $user_id = session("wz-user.id");
        $id = $request->post("id");
        $type = $request->post("type");
        if($type=='group'){
            //验证是否群主
        }else{
            $where = "(sender_id ='{$user_id}' and receiver_id = '{$id}') or (sender_id ='{$id}' and receiver_id = '{$user_id}')";
            Messages::where("session_type",Messages::SESSION_PRIVATE)->whereRaw($where)->delete();
        }
        return json(['code'=>0,'msg'=>'ok']);
    }
    public function groupMembers(Request $request){
        $id = $request->get('id');
        $list = GroupMembers::where('group_id', $id)
        ->with("user:id,avatar,nickname")
        ->where("status", "1")
        ->get();
        $onlines = wz_get_group_online_users($id);
        $data =[];
        foreach ($list as $item){
            $data[] = [
                'id'=>$item->user->id,
                'avatar'=>$item->user->avatar,
                'role'=>$item->role,
                'nickname'=>$item->user->nickname,
                'online'=> in_array($item->user->id, $onlines)
            ];
        }
        usort($data, function($a, $b) {
            if ($a['online'] == $b['online']) {
                return strcmp($a['nickname'], $b['nickname']);
            }
            return $b['online'] <=> $a['online'];
        });
        return json(['code'=>0,'data'=>$data]);
    }
    
    /**
     * 上传文件
     */
    public function uploadFile(Request $request)
    {
        
    }
    
    
    
    
    
    private function getFileType(string $mime): int
    {
        if (str_contains($mime, 'image')) return 1;
        if (str_contains($mime, 'audio')) return 2;
        if (str_contains($mime, 'video')) return 3;
        return 4; // 其他文件
    }
}